package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigSampleReportPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigSampleReportRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigSampleReportSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigSampleReportDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigSampleReportMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.CONFIG_SAMPLE_REPORT_NOT_EXISTS;

/**
 * 样品报表关系 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigSampleReportServiceImpl implements ConfigSampleReportService {

    @Resource
    private ConfigSampleReportMapper configSampleReportMapper;

    @Override
    public ConfigSampleReportRespVO createConfigSampleReport(ConfigSampleReportSaveReqVO createReqVO) {
        // 插入
        ConfigSampleReportDO configSampleReport = BeanUtils.toBean(createReqVO, ConfigSampleReportDO.class);
        configSampleReportMapper.insert(configSampleReport);
        // 返回
        return BeanUtils.toBean(configSampleReport, ConfigSampleReportRespVO.class);
    }

    @Override
    public void updateConfigSampleReport(ConfigSampleReportSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigSampleReportExists(updateReqVO.getId());
        // 更新
        ConfigSampleReportDO updateObj = BeanUtils.toBean(updateReqVO, ConfigSampleReportDO.class);
        configSampleReportMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigSampleReport(Long id) {
        // 校验存在
        validateConfigSampleReportExists(id);
        // 删除
        configSampleReportMapper.deleteById(id);
    }

    @Override
        public void deleteConfigSampleReportListByIds(List<Long> ids) {
        // 校验存在
        validateConfigSampleReportExists(ids);
        // 删除
        configSampleReportMapper.deleteByIds(ids);
        }

    private void validateConfigSampleReportExists(List<Long> ids) {
        List<ConfigSampleReportDO> list = configSampleReportMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_SAMPLE_REPORT_NOT_EXISTS);
        }
    }

    private void validateConfigSampleReportExists(Long id) {
        if (configSampleReportMapper.selectById(id) == null) {
            throw exception(CONFIG_SAMPLE_REPORT_NOT_EXISTS);
        }
    }

    @Override
    public ConfigSampleReportDO getConfigSampleReport(Long id) {
        return configSampleReportMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigSampleReportDO> getConfigSampleReportPage(ConfigSampleReportPageReqVO pageReqVO) {
        return configSampleReportMapper.selectPage(pageReqVO);
    }

}